#include <bits/stdc++.h>
using namespace std;
int main(){
       ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
int n,k,x;
cin >>n>>k>>x;
int s=n-1;
int sk=s*s-(k-s)*2;
vector <int> rez;
//cout <<sk<<endl;

vector <int> DP(sk+1,1000000);
DP[0]=0;
for(int i=1;i<=sk;i++){
    for(int j=1;j<=sqrt(i);j++){
        DP[i]=min(DP[i-j*j]+1,DP[i]);
    }
}

if(DP[sk]>s){
    cout <<-1<<endl;
    return 0;
}
cout <<1<<" ";
int Far=x+1;
for(int i=0;i<rez.size();i++){
        for(int j=0;j<rez[i];j++)
    cout <<Far<<" ";
    Far+=x;
}
cout <<endl;
}